require 'httparty'
require_relative 'result'

module PDFire
  class Conversion < Result
    attr_reader :initialized_at, :finished_at, :status, :error, :result

    def initialize(initialized_at, finished_at, status, error, result)
      @initialized_at = initialized_at
      @finished_at = finished_at
      @status = status
      @error = error
      @result = result
    end

    def bytes()
      HTTParty.get(self.result.url).body.bytes
    end
  end

  class Conversion::Result
    attr_reader :expires_at, :size, :runtime, :url

    def initialize(expires_at, size, width, height, runtime, url)
      @expires_at = expires_at
      @size = size
      @width = width
      @height = height
      @runtime = runtime
      @url = url
    end
  end
end
