module PDFire
  class ConversionParams
    # @return [String]
    attr_accessor :html
    # @return [String]
    attr_accessor :url
    # @return [Boolean]
    attr_accessor :cdn
    # @return [Boolean, Hash]
    attr_accessor :storage
    # @return [Boolean]
    attr_accessor :landscape
    # @return [Boolean]
    attr_accessor :print_background
    # @return [Boolean]
    attr_accessor :scale
    # @return [Float]
    attr_accessor :format
    # @return [Integer, String]
    attr_accessor :paper_width
    # @return [Integer, String]
    attr_accessor :paper_height
    # @return [Integer, String]
    attr_accessor :margin
    # @return [Integer, String]
    attr_accessor :margin_top
    # @return [Integer, String]
    attr_accessor :margin_right
    # @return [Integer, String]
    attr_accessor :margin_bottom
    # @return [Integer, String]
    attr_accessor :margin_left
    # @return [String]
    attr_accessor :page_ranges
    # @return [String]
    attr_accessor :header_template
    # @return [String]
    attr_accessor :footer_template
    # @return [Boolean]
    attr_accessor :prefer_css_page_size
    # @return [Integer, String]
    attr_accessor :viewport_width
    # @return [Integer, String]
    attr_accessor :viewport_height
    # @return [Boolean]
    attr_accessor :block_ads
    # @return [String]
    attr_accessor :selector
    # @return [String]
    attr_accessor :wait_for_selector
    # @return [Integer]
    attr_accessor :wait_for_selector_timeout
    # @return [String]
    attr_accessor :wait_until
    # @return [Integer]
    attr_accessor :wait_until_timeout
    # @return [Integer]
    attr_accessor :delay
    # @return [Integer]
    attr_accessor :timeout
    # @return [Hash]
    attr_accessor :headers
    # @return [String]
    attr_accessor :emulate_media
    # @return [String]
    attr_accessor :owner_password
    # @return [String]
    attr_accessor :user_password
    # @return [Boolean]
    attr_accessor :allow_error_page
    # @return [Boolean]
    attr_accessor :optimize

    def to_map
      map = {}

      map['html'] = @html if @html != nil
      map['url'] = @url if @url != nil
      map['cdn'] = @cdn if @cdn != nil
      map['storage'] = @storage if @storage != nil
      map['landscape'] = @landscape if @landscape != nil
      map['printBackground'] = @print_background if @print_background != nil
      map['scale'] = @scale if @scale != nil
      map['format'] = @format if @format != nil
      map['paperWidth'] = @paper_width if @paper_width != nil
      map['paperHeight'] = @paper_height if @paper_height != nil
      map['margin'] = @margin if @margin != nil
      map['marginTop'] = @margin_top if @margin_top != nil
      map['marginRight'] = @margin_right if @margin_right != nil
      map['marginBottom'] = @margin_bottom if @margin_bottom != nil
      map['marginLeft'] = @margin_left if @margin_left != nil
      map['pageRanges'] = @page_ranges if @page_ranges != nil
      map['headerTemplate'] = @header_template if @header_template != nil
      map['footerTemplate'] = @footer_template if @footer_template != nil
      map['preferCSSPageSize'] = @prefer_css_page_size if @prefer_css_page_size != nil
      map['viewportWidth'] = @viewport_width if @viewport_width != nil
      map['viewportHeight'] = @viewport_height if @viewport_height != nil
      map['blockAds'] = @block_ads if @block_ads != nil
      map['selector'] = @selector if @selector != nil
      map['waitForSelector'] = @wait_for_selector if @wait_for_selector != nil
      map['waitForSelectorTimeout'] = @wait_for_selector_timeout if @wait_for_selector_timeout != nil
      map['waitUntil'] = @wait_until if @wait_until != nil
      map['waitUntilTimeout'] = @wait_until_timeout if @wait_until_timeout != nil
      map['delay'] = @delay if @delay != nil
      map['timeout'] = @timeout if @timeout != nil
      map['headers'] = @headers if @headers != nil
      map['emulateMedia'] = @emulate_media if @emulate_media != nil
      map['ownerPassword'] = @owner_password if @owner_password != nil
      map['userPassword'] = @user_password if @user_password != nil
      map['allowErrorPage'] = @allow_error_page if @allow_error_page != nil
      map['optimize'] = @optimize if @optimize != nil

      return map
    end
  end
end
