module PDFire
  class MergeParams
    # @return [Array<PDFire::ConversionParams>]
    attr_accessor :documents
    # @return [Boolean]
    attr_accessor :cdn
    # @return [Boolean, Hash]
    attr_accessor :storage
    # @return [String]
    attr_accessor :owner_password
    # @return [String]
    attr_accessor :user_password

    def initialize(documents = [])
      @documents = documents
      @cdn = nil
      @storage = nil
      @owner_password = nil
      @user_password = nil
    end

    def to_map
      map = {}
      map['documents'] = @documents.map { |doc| doc.to_map } if @documents.length > 0
      map['cdn'] = @cdn if @cdn != nil
      map['storage'] = @storage if @storage != nil
      map['ownerPassword'] = @owner_password if @owner_password != nil
      map['userPassword'] = @user_password if @user_password != nil

      return map
    end
  end
end
